#include "zpack.h"
#include "inflate.c"
#include "deflate.c"

static ushort (*ZPACK_US)(ushort i);
static uint (*ZPACK_UI)(uint i);
static ulong (*ZPACK_UL)(ulong i);

#include "zpack_util.c"
#include "zpack_image.c"
#include "zpack_spans.c"
#include "zpack_cache.c"
#include "zpack_io.c"
#include "zpack_dir.c"

static ushort zpack_us(ushort i) { return(i); }
static uint zpack_ui(uint i) { return(i); }
static ulong zpack_ul(ulong i) { return(i); }

static ushort zpack_swus(ushort i) { return((i>>8)|(i<<8)); }
static uint zpack_swui(uint i)
	{ return((i>>24)|(i<<24)|((i>>8)&0xFF00)|((i<<8)&0xFF0000)); }
static ulong zpack_swul(ulong i)
{
	return(zpack_swui((uint)(i>>32))|((ulong)zpack_swui((uint)i)<<32));
//	return(	((i>>56)&0x00000000000000FF)|((i<<56)&0xFF00000000000000)|
//		((i>>48)&0x000000000000FF00)|((i<<48)&0x00FF000000000000)|
//		((i>>24)&0x0000000000FF0000)|((i<<24)&0x0000FF0000000000)|
//		((i>>8) &0x00000000FF000000)|((i<<8) &0x000000FF00000000));
}

int zpack_endianess;	//0=LE, 1=BE

int ZPACK_Init()
{
	byte ut[4]={0x12, 0x34, 0x56, 0x78};

	if(sizeof(byte)!=1)
	{
		printf("sizeof(byte)!=1\n");
		return(-1);
	}
	if(sizeof(ushort)!=2)
	{
		printf("sizeof(ushort)!=2\n");
		return(-1);
	}
	if(sizeof(uint)!=4)
	{
		printf("sizeof(uint)!=4\n");
		return(-1);
	}
	if(sizeof(ulong)!=8)
	{
		printf("sizeof(ulong)!=8\n");
		return(-1);
	}

	if(sizeof(struct ZPACK_DirEntry_ds)!=64)
	{
		printf("sizeof(struct ZPACK_DirEntry_ds)!=64\n");
		return(-1);
	}

	if(*((uint*)(&ut))==0x78563412)
	{
		zpack_endianess=0;
		ZPACK_US=&zpack_us;
		ZPACK_UI=&zpack_ui;
		ZPACK_UL=&zpack_ul;
	}
	if(*((uint*)(&ut))==0x12345678)
	{
		zpack_endianess=1;
		ZPACK_US=&zpack_swus;
		ZPACK_UI=&zpack_swui;
		ZPACK_UL=&zpack_swul;
	}
}
